﻿using FileReadSample.Data;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Storage;
using Windows.Storage.Pickers;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
//ToArray()를 사용하기 위해 필요
using System.Runtime.InteropServices.WindowsRuntime;
using System.Text;

// The Item Detail Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234232

namespace FileReadSample
{
    public sealed partial class ItemDetailPage : FileReadSample.Common.LayoutAwarePage
    {
        public ItemDetailPage()
        {
            this.InitializeComponent();

            //스크롤 뷰어 뷰 체인지 이벤트를 이용해서 위치 표시
            scrollViewer.ViewChanged += 
                (s, e) => 
                {
                    scrollPos.Text = scrollViewer.HorizontalOffset.ToString();
                };
        }

        protected override void LoadState(Object navigationParameter, Dictionary<String, Object> pageState)
        {
        }

        protected override void SaveState(Dictionary<String, Object> pageState)
        {
        }

        /// <summary>
        /// 택스트 파일 열기
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private async void Button_Click_1(object sender, RoutedEventArgs e)
        {
            //파일 피커
            FileOpenPicker openPicker = new FileOpenPicker();
            openPicker.ViewMode = PickerViewMode.List;
            openPicker.SuggestedStartLocation = PickerLocationId.Downloads;
            openPicker.FileTypeFilter.Add(".txt");
            //파일 하나 선택
            StorageFile file = await openPicker.PickSingleFileAsync();
            if (file != null)
            {
                //파일이 존재하면
                //내용을 버퍼에 읽어 들이고
                var buffer = await FileIO.ReadBufferAsync(file);
                //배열로 바꾸고
                var fileData = buffer.ToArray();
                //euc-Kr로 인코딩
                var encoding = Encoding.GetEncoding("euc-Kr");
                //파일명 출력
                title.Text = file.Name;
                //파일 패스 출력
                subtitle.Text = file.Path;
                //내용 출력
                var contents = encoding.GetString(fileData, 0, fileData.Length);
                textContent.Text = contents;
            }
        }
    }
}
